/***************************************************************/
/* Berechnung der Zahl e = 2.7182818... auf Basis der Formel:  */
/*							       */
/* e = 1/0! + 1/1! + 1/2! + 1/3! + 1/4! + ...		       */
/*							       */
/* von Reinhard Scharnagl, 40227 Duesseldorf, 1992 - 1994,     */
/* unter der Benutzung von PureC, in der Version Feb 03 1992   */
/* und spaeter Borland C++ for OS/2 in diversen Versionen      */
/* (Tab = 8)						       */
/***************************************************************/

/* Anpassungen */

#ifdef __TURBOC__
#pragma warn -use
#endif

typedef unsigned short UWord;

/* eingebundene Help-Dateien */

#include <stdio.h>
#include <stdlib.h>

/* lokale Prototypen */

void big_set (UWord *field, UWord value,    int length);
int  big_div (UWord *field, UWord divisor,  int length);
void big_add (UWord *field, UWord *summand, int length);
void big_mul (UWord *field, UWord factor,   int length);
void big_out (UWord *field, int   digits,   int length);
int  main    (int ac, char *av[]);

typedef UWord BUFFER[4151*sizeof(UWord)];

/***************************************************************/
/* Aufruf "CALC_PI.TTP nnn" mit 0 < nnn < 20000 Dezimalstellen */
/***************************************************************/

int main
  (int ac, char *av[])
{ register UWord divisor;
  register int huge;
  int digits, arg;
  UWord *sum,		     /* langes Rechenfeld 1 */
	   *quo;		     /* langes Rechenfeld 2 */

  $TABLE GetRam 	 /* genuegend Speicher verfuegbar ? */
  /*--------------------------------------------------------*/
  $C ((sum = (UWord *)malloc(sizeof(BUFFER))) == 0L)
				/* erster Puffer zu Gross ? */	$ Y N N
     ((quo = (UWord *)malloc(sizeof(BUFFER))) == 0L)
			       /* zweiter Puffer zu Gross ? */	$ . Y N
  $A printf("Speicher reicht nicht!\n\n");   /* Fehler-Text */	$ X X .
     return 1;				/* Error, Abbruch ! */	$ X X .
  $END

  $TABLE AskParm	  /* Nachfrage, wenn ohne Parameter */
  /*--------------------------------------------------------*/
  $C (ac < 2)			       /* keine Argumente ? */	$ Y N
  $A printf("gewuenschte Genauigkeit? ");    /* User fragen */	$ X .
     scanf("%s", av[ac++] = (char *)sum);   /* hole Antwort */	$ X .
     arg = 0;		     /* starte vor erstem Parameter */	$ X X
  $END

  $TABLE DoActArg	 /* verarbeite anstehende Argumente */
  /*--------------------------------------------------------*/
  $C (++arg >= ac)		    /* kein Argument mehr ? */	$ Y N
  $A return 0;			    /* OK, alles erledigt ! */	$ X .
  $END

  $TABLE ReadArg		/* lese Ziffern-Anforderung */
  /*--------------------------------------------------------*/
  $C (sscanf(av[arg],"%d",&digits))   /* Zahl einlesen OK ? */	$ Y Y N
     (digits <= 0)		    /* illegale Forderung ? */	$ Y N .
  $A printf("Eingabe fehlerhaft: %s\n\n", av[arg]);
					     /* Fehler-Text */	$ X . X
     goto DoActArg;		   /* Anforderung skippen ! */	$ X . X
  $END

  $TABLE StartCalc		    /* Start der Berechnung */
  /*--------------------------------------------------------*/
     printf("Berechnung von e mit %d Stellen:\n\n",digits);
				     /* Titelzeile ausgeben */
     huge = (int)((digits*1000L)/(301L*8*sizeof(UWord))+3);
		/* berechne obere Schranke der Rechenfelder */
     big_set(sum, 2, huge);  /* initialisiere Summe auf 1.0 */
 $END

  $TABLE DoCalc 		    /* Start der Berechnung */
  /*--------------------------------------------------------*/
     big_set(quo, 1, huge);  /* initialisiere Quot. auf 1.0 */
     for (divisor = 1; ; )	     /* Iterationsschleife: */
  $C (big_div(quo, ++divisor, huge)) /* Quotient relevant ? */	$ Y N
  $A big_add(sum, quo, huge);	      /* zur Summe addieren */	$ X .
     break;			     /* Iteration beenden ! */	$ . X
  $END

  $TABLE PrintNum		     /* Ende der Berechnung */
  /*--------------------------------------------------------*/
     big_out(sum, digits, huge);       /* Resultat ausgeben */
     goto DoActArg;	     /* zur naechsten Anforderung ! */
  $END
}

void big_set
  (UWord *field, UWord value, int length)
{
  $TABLE BigSet 		/* Initialisiere Rechenfeld */
  /*--------------------------------------------------------*/
     *(field++) = value;	    /* uebernehme Kopf-Wert */
     for (;;)			     /* Iterationsschleife: */
  $C (--length) 			   /* noch zu tun ? */	$ Y N
  $A *(field++) = 0;			   /* Rest loeschen */	$ X .
     break;			     /* Iteration beenden ! */	$ . X
  $END
}

int big_div
  (UWord *field, UWord divisor, int length)
{ register unsigned long accumulator;
  register UWord *p_work, *p_bound;
  register int any_bits;

  $TABLE BigDiv 		 /* Division auf Rechenfeld */
  /*--------------------------------------------------------*/
     accumulator = 0L;		 /* Zwischensumme noch leer */
     any_bits = 0;		 /* noch nichts verarbeitet */
     p_work = field;		    /* setze Arbeits-Zeiger */
     p_bound = &p_work[length];       /* setze Grenz-Zeiger */
     for (; ; ++p_work) 	     /* Iterationsschleife: */
  $C (p_work < p_bound) 		   /* noch zu tun ? */	$ Y Y Y N
     ((accumulator += *p_work) != 0L)	     /* Teilsumme ? */	$ Y Y N .
     ((*p_work = (UWord)(accumulator/divisor)) != 0)
					  /* Teilresultat ? */	$ Y N . .
  $A any_bits = 1;		      /* merke Verarbeitung */	$ X . . .
     accumulator %= divisor;
     accumulator <<= (8*sizeof(UWord)); /* schiften */	$ X X . .
     return any_bits;		      /* Ende und Antwort ! */	$ . . . X
  $END
}

void big_add
  (UWord *field, UWord *summand, int length)
{ register unsigned long accumulator;
  register UWord *p_fld, *p_smd;

  $TABLE BigAdd 		 /* Addition auf Rechenfeld */
  /*--------------------------------------------------------*/
     accumulator = 0L;		 /* Zwischensumme noch leer */
     p_fld = &field[length];
     p_smd = &summand[length];	    /* setze Arbeits-Zeiger */
     for (;;)			     /* Iterationsschleife: */
  $C ((--p_smd, --p_fld) >= field)	   /* noch zu tun ? */	$ Y N
  $A accumulator >>= (8*sizeof(UWord));
     accumulator += *p_fld;
     accumulator += *p_smd;
     *p_fld = (UWord)accumulator;	   /* Teil-Addition */	$ X .
     break;			     /* Iteration beenden ! */	$ . X
  $END
}

void big_mul
  (UWord *field, UWord factor, int length)
{ register unsigned long accumulator, l_factor;
  register UWord *p_work;

  $TABLE BigMult	   /* Multiplikation auf Rechenfeld */
  /*--------------------------------------------------------*/
     accumulator = 0L;		 /* Zwischensumme noch leer */
     l_factor = factor; 	      /* Faktor verlaengern */
     p_work = &field[length];	    /* setze Arbeits-Zeiger */
     for (;;)			     /* Iterationsschleife: */
  $C (--p_work >= field)		   /* noch zu tun ? */	$ Y N
  $A accumulator >>= (8*sizeof(UWord));
     accumulator += *p_work * l_factor;
     *p_work = (UWord)accumulator;/* Teil-Multiplikation */	$ X .
     break;			     /* Iteration beenden ! */	$ . X
  $END
}

void big_out
  (UWord *field, int digits, int length)
{ register int count;

  $TABLE BigOut 		 /* Ausgabe des Rechenfelds */
  /*--------------------------------------------------------*/
     for (count = 0, digits += (3-1); ; count += 3)
				     /* Iterationsschleife: */
  $C (count < digits)			   /* noch zu tun ? */	$ Y N
  $A printf("%03u",field[0]);
     printf(!count ? "." : ((count+3) % (18*3)) ? " " : "\n");
     field[0] = 0;
     big_mul(field, 1000, length);	    /* Teil-Ausgabe */	$ X .
     printf("\n\n");		      /* Ausgabe Trennzeile */	$ . X
     break;			     /* Iteration beenden ! */	$ . X
  $END
}
