/***************************************************************/
/* Berechnung der Zahl pi = 3.1415926... auf Basis der Formel: */
/*							       */
/* pi	  4    1     1	4      1      1  4	1	       */
/* --- = (- - ---) - -(--- - -----) + -(--- - -----) - + ...   */
/*  4	  5   239    3 5^3   239^3    5 5^5   239^5	       */
/*							       */
/* von Reinhard Scharnagl, 40227 Duesseldorf, 1992 - 1994,     */
/* unter der Benutzung von PureC, in der Version Feb 03 1992   */
/* und spaeter Borland C++ for OS/2 in diversen Versionen      */
/* (Tab = 8)						       */
/***************************************************************/

/* Anpassungen */

#ifdef __TURBOC__
#pragma warn -use
#endif

/* eingebundene Help-Dateien */

#include <stdio.h>
#include <stdlib.h>

typedef unsigned short UWord;

/* lokale Prototypen */

void big_set (UWord *field, UWord value,       int length);
int  big_div (UWord *field, UWord divisor,     int length);
void big_add (UWord *field, UWord *summand,    int length);
void big_sub (UWord *field, UWord *subtrahend, int length);
void big_mul (UWord *field, UWord factor,      int length);
void big_out (UWord *field, int   digits,      int length);
void big_cpy (UWord *field, UWord *source,     int length);
int  main    (int ac, char *av[]);

typedef UWord BUFFER[4151*sizeof(UWord)];

/***************************************************************/
/* Aufruf "CALC_PI.TTP nnn" mit 0 < nnn < 20000 Dezimalstellen */
/***************************************************************/

int main
  (int ac, char *av[])
{ register UWord divisor;
  register int huge;
  int digits, arg;
  UWord *sum,		     /* langes Rechenfeld 1 */
	   *quo,		     /* langes Rechenfeld 2 */
	   *buf;		     /* langes Rechenfeld 3 */

 GetRam: {
  {
   if ((sum = (UWord *)malloc(sizeof(BUFFER))) == 0L)  {
    goto aCGetRam;
   }{
    if ((quo = (UWord *)malloc(sizeof(BUFFER))) == 0L)  {
     goto aCGetRam;
    }{
     if ((buf = (UWord *)malloc(sizeof(BUFFER))) == 0L)  {
      aCGetRam:
      printf("Speicher reicht nicht!\n\n");
      return 1;
     }{
 }}}}}
  
 AskParm: {
  {
   if (ac < 2) {
    printf("gewuenschte Genauigkeit? ");
    scanf("%s", av[ac++] = (char *)sum);
    goto cBAskParm;
   }{
    cBAskParm:
    arg = 0;
 }}}

 DoActArg: {
  {
   if (++arg >= ac) {
    return 0;
   }{
 }}}

 ReadArg: {
  {
   if (sscanf(av[arg],"%d",&digits)) {
    if (digits <= 0) {
     goto aCReadArg;
    }{
   }} else {
    aCReadArg:
    printf("Eingabe fehlerhaft: %s\n\n", av[arg]); 
    goto DoActArg;
 }}}

 StartCalc: {
  {
  printf("Berechnung von pi mit %d Stellen:\n\n",digits);
    huge = (int)((digits*1000L)/(301L*8*sizeof(UWord))+3);
    big_set(sum,     0, huge);
 }}

 DoCalcPh1: {
  big_set(quo, 4*4*5, huge); for (divisor = 1; ; divisor += 2)
  {
   if ( big_div(quo, 5*5, huge), big_cpy(buf, quo, huge),
  big_div(quo, divisor, huge)) {
    if (divisor & 2) {
     big_sub(sum, quo, huge);
     goto cBDoCalcPh1;
    }{
     big_add(sum, quo, huge);
     cBDoCalcPh1:
     big_cpy(quo, buf, huge);
   }} else {
    break;
 }}}

 DoCalcPh2: {
  big_set(quo, 4*239, huge); for (divisor = 1; ; divisor += 2)
  {
   if ( big_div(quo, 239*239, huge), big_cpy(buf,	quo, huge),
  big_div(quo, divisor, huge)) {
    if (divisor & 2) {
     big_add(sum, quo, huge);
     goto cBDoCalcPh2;
    }{
     big_sub(sum, quo, huge);
     cBDoCalcPh2:
     big_cpy(quo, buf, huge);
   }} else {
    break;
 }}}

 PrintNum: {
  {
  big_out(sum, digits, huge); goto DoActArg;
 }}
}

void big_set
  (UWord *field, UWord value, int length)
{ 
 BigSet: {
  *(field++) = value; for (;;)
  {
   if (--length) {
    *(field++) = 0;
   } else {
    break;
 }}}
}

void big_cpy
  (UWord *field, UWord *source, int length)
{ 
 BigCopy: {
  for (;;)
  {
   if (--length) {
    *(field++) = *(source++);
   } else {
    break;
 }}}
}

int big_div
  (UWord *field, UWord divisor, int length)
{ register unsigned long accumulator;
  register UWord *p_work, *p_bound;
  register int any_bits;

 BigDiv: {
  accumulator = 0L; any_bits = 0; p_work = field;
    p_bound = &p_work[length]; for (; ; ++p_work)
  {
   if (p_work < p_bound) {
    if ((accumulator += *p_work) != 0L) {
     if ((*p_work = (UWord)(accumulator/divisor)) != 0)  {
      any_bits = 1;
      goto bBBigDiv;
     }{
      bBBigDiv:
      accumulator %= divisor; accumulator <<= (8*sizeof(UWord));
    }} else {
   }} else {
    return any_bits;
 }}}
}

void big_add
  (UWord *field, UWord *summand, int length)
{ register unsigned long accumulator;
  register UWord *p_fld, *p_smd;

 BigAdd: {
  accumulator = 0L; p_fld = &field[length]; p_smd = &summand[length];
    for (;;)
  {
   if ((--p_smd, --p_fld) >= field) {
    accumulator >>= (8*sizeof(UWord)); accumulator += *p_fld;
      accumulator += *p_smd; *p_fld = (UWord)accumulator;
   } else {
    break;
 }}}
}

void big_sub
  (UWord *field, UWord *subtrahend, int length)
{ register unsigned long accumulator;
  register UWord *p_fld, *p_std;

 BigSub: {
  accumulator = 0L; p_fld = &field[length]; p_std = &subtrahend[length];
    for (;;)
  {
   if ((--p_std, --p_fld) >= field) {
    accumulator >>= (8*sizeof(UWord)); accumulator += *p_fld;
      accumulator += (UWord)~*p_std; *p_fld = (UWord)accumulator;
   } else {
    break;
 }}}
}

void big_mul
  (UWord *field, UWord factor, int length)
{ register unsigned long accumulator, l_factor;
  register UWord *p_work;

 BigMult: {
  accumulator = 0L; l_factor = factor; p_work = &field[length]; for (;;)
  {
   if (--p_work >= field) {
    accumulator >>= (8*sizeof(UWord)); accumulator += *p_work * l_factor;
      *p_work = (UWord)accumulator;
   } else {
    break;
 }}}
}

void big_out
  (UWord *field, int digits, int length)
{ register int count;

 BigOut: {
  for (count = 0, digits += (3-1); ; count += 3)
  {
   if (count < digits) {
    printf("%03u",field[0]);
      printf(!count ? "." : ((count+3) % (18*3)) ? " " : "\n");
      field[0] = 0; big_mul(field, 1000, length);
   } else {
    printf("\n\n");
    break;
 }}}
}
