#define DT_TRACE 1
static void __cnt(int n);
extern void __rgs(int *p);
/* ET-Beispiel-Hauptprogramm: (C) 1990/Jan/06 - 1991/Okt/16,    */
/*                             R. Scharnagl, 4000 Duesseldorf 1 */

  /*============================================================*/
  /* PRIM.T - Demonstrations-Hauptprogramm zur Benutzung von    */
  /* Entscheidungs-Tabellen (ETs) in C-Programmen mittels des   */
  /* Precompilers DTT.                                          */
  /*------------------------------------------------------------*/
  /* Eine ET hat hier formal das folgende Erscheinungsbild,     */
  /* (wobei eine evtl. ELSE-Spalte nur aus (.) besteht):        */
  /*                                                            */
  /* Start-Makro:       $TABLE <name>                           */
  /* Bedingungsmakro:   $C <cond.>      $ <flags (Y|N|.)> ...   */
  /*                       <cond.>      $ <flags (Y|N|.)> ...   */
  /*                       ...                                  */
  /* Aktionsmakro:      $A <statm.>     $ <flags (X|.)>   ...   */
  /*                       <statm.>     $ <flags (x|.)>   ...   */
  /*                       ...                                  */
  /* Ende-Makro:        $END                                    */
  /*                                                            */
  /* Es sind auch modifizierte ET-Formen moeglich. So duerfen   */
  /* zwischen $TABLE und $C eine Reihe von Anweisungen stehen   */
  /* (oder auch Schleifenkoepfe), die als gemeinsame Liste      */
  /* vorgeschalteter Aktionen aufgefasst wird. Die $C- und      */
  /* $A-Teile koennen auch gaenzlich fehlen, es liegt dann      */
  /* eine reine Aktionstabelle vor. Im $C-Teil kann das "if"    */
  /* des Bedingungsteils auch entfallen, es wird dann spaeter   */
  /* ergaenzt. Eine logische Zeile kann sich ueber mehrere      */
  /* physische Zeilen erstrecken. Innerhalb von ETs sind auch   */
  /* Kommentare, falls nicht mehrzeilig, erlaubt.               */
  /*------------------------------------------------------------*/
  /* DTT kann mit diversen Optionen aufgerufen werden:          */
  /*   -T  :  Trace generating (Zaehlung beim Programmlauf)     */
  /*   -C  :  Copy tables (ETs werden als Kommentar wiederholt) */
  /*   -S  :  Silent (alle Meldungen werden unterdrueckt)       */
  /*   -M  :  Mark ELSE usage (protokolliere ELSE-Benutztung)   */
  /*   -N  :  No ANSI standard (Fuer C-Compiler alten Typs)     */
  /*------------------------------------------------------------*/
  /* Im Trace-Mode wird mit dem zugelinkten Modul TRACE.O nach  */
  /* dem Programm-Ende eine Uebersicht aller angesprochenen und */
  /* mit der Trace-Option uebersetzten Module aufgelistet.      */
  /* Die Anzahl der Programmdurchlaeufe jeder Tabellenregel ist */
  /* darin ersichtlich. Nicht vollstaendig durchlaufene ETs     */
  /* werden mit '?' markiert, unberuehrte durch '*'. So laesst  */
  /* sich die Unvollstendigkeit einer Testumgebung bzw. uner-   */
  /* reichbarer Programmcode leichter erkennen und abaendern.   */
  /* Auch beim Test von GEM-Anwendungen ist durch ein (DT_TRACE */
  /* bedingt compiliertes) Umlenken von 'stdout' vor dem Pro-   */
  /* grammende eine Dokumentation von Dialoganwendungssitzungen */
  /* in aehnlicher Weise moeglich.                              */
  /*------------------------------------------------------------*/
  /* DTT verifiziert die Korrektheit der ETs, die Vollstaendig- */
  /* keit der Regeln und gibt entsprechende Hinweise aus.       */
  /*============================================================*/

#ifdef __STDC__
#include <stdlib.h>
#define _(parms) parms /* prototyp */
#else
#define void  /* */
#define const /* */
#define _(parms) ()    /* old declaration */
#endif

/* Benoetigte Copy-Bibliothek */
#include <stdio.h>

#ifdef __TURBOC__
#pragma warn -use
#endif

/* Prototypen */
void    Vorbereitung    _((void)); 
void    Hauptteil       _((void));
int     main            _((void));

/* Externals */
extern  void Outc       _((char c));
extern  void Ausgabe    _((int i));

/* Globale Variablen */
int     test, teil, quot, zaehler, anzahl;

int main()             /*=======================================*/
{                      /* Berechnung der ersten N.N. Primzahlen */
                       /*=======================================*/

/*
  #TABLE Steuerung                     (* REINE AKTIONS-TABELLE *)
  (*------------------------------------------------------------*)
     Vorbereitung();             (* Vorbereitungen durchfuehren *)
     Hauptteil();             (* eigentliches Programm aufrufen *)
     return 0;                                 (* normales Ende *)
  #END
*/
 Steuerung: {
  {
   __cnt(0);
  Vorbereitung(); Hauptteil(); return 0;
 }}
}

void Vorbereitung()    /*=======================================*/
{                      /* Einmalige Vorbereitungen durchfuehren */
                       /*=======================================*/

/*
  #TABLE Titelzeile                    (* REINE AKTIONS-TABELLE *)
  (*------------------------------------------------------------*)
     Ausgabe(anzahl = 260);                 (* Anzahl festlegen *)
     puts(" PRIMZAHLEN:");         (* die Ueberschrift ausgeben *)
  #END
*/
 Titelzeile: {
  {
   __cnt(1);
  Ausgabe(anzahl = 260); puts(" PRIMZAHLEN:");
 }}

/*
  #TABLE Grundwert                           (* ET MIT 2 REGELN *)
  (*------------------------------------------------------------*)
  #C (test == 0)       (* eigentlich ueberfluessig, immer: true *)  $ Y N
  #A test = 1;                      (* setze die erste Testzahl *)  $ X .
     zaehler = 0;             (* setze Primzahl-Zaehler zurueck *)  $ X .
  #END
*/
 Grundwert: {
  {
   if (test == 0) {
    __cnt(2);
    test = 1;
    zaehler = 0;
   } else {
    __cnt(3);
 }}}
}

void Hauptteil()                /*==============================*/
{                               /* Eigentlicher Primzahl-Zyklus */
                                /*==============================*/

/*
  #TABLE neue_Zahl                           (* ET MIT 2 REGELN *)
  (*------------------------------------------------------------*)
  #C (test > 2)           (* gerade Primzahl schon unmoeglich ? *)  $ N Y
  #A test += 1;                      (* dann zur naechsten Zahl *)  $ X .
     test += 2;            (* hier zur naechsten ungeraden Zahl *)  $ . X
     teil = 1;       (* setze ersten (verbrauchten) Teiler fest *)  $ X X
  #END
*/
 neue_Zahl: {
  {
   if (test > 2) {
    __cnt(5);
    test += 2;
    goto cAneue_Zahl;
   }{
    __cnt(4);
    test += 1;
    cAneue_Zahl:
    teil = 1;
 }}}

/*
  #TABLE neuer_Test          (* ET MIT VORAKTIONEN UND 3 REGELN *)
  (*------------------------------------------------------------*)
     teil += 1;               (* Uebergang zum naechsten Teiler *)
     quot = test / teil;             (* berechne den Quotienten *)
  #C (quot < teil)             (* Wurzel schon ueberschritten ? *)  $ Y N N
     (quot * teil == test)                (* war Zahl teilbar ? *)  $ . Y N
  #A goto $T;           (* $T-Makro: wiederhole die ET von vorn *)  $ . . X
     goto neue_Zahl;            (* neuen Test-Kandidaten suchen *)  $ . X .
  #END
*/
 neuer_Test: {
  teil += 1; quot = test / teil;
  {
   if (quot < teil) {
    __cnt(6);
   } else {
    if (quot * teil == test) {
     __cnt(7);
     goto neue_Zahl;
    }{
     __cnt(8);
     goto neuer_Test;
 }}}}

/*
  #TABLE Primzahl   (* ET MIT VORAKTIONEN UND 3 REGELN MIT ELSE *)
  (*------------------------------------------------------------*)
     zaehler += 1;                      (* zaehle neue Primzahl *)
     Ausgabe(test);                  (* drucke die Primzahl aus *)
  #C if (zaehler < anzahl)      (* noch nicht genug ermittelt ? *)  $ N Y .
     if (zaehler % 13)            (* hat die Zeile noch Platz ? *)  $ . Y .
  #A Outc('\n');                           (* die Zeile beenden *)  $ X . X
     goto neue_Zahl;              (* suche naechsten Kandidaten *)  $ . X X
     return;                                          (* fertig *)  $ X . .
  #END
*/
 Primzahl: {
  zaehler += 1; Ausgabe(test);
  {
   if (zaehler < anzahl) {
    if (zaehler % 13) {
     __cnt(10);
     goto neue_Zahl;
   }} else {
    __cnt(9);
    Outc('\n');
    return;
   }
   __cnt(11);
   Outc('\n');
   goto neue_Zahl;
 }}

/*
  #TABLE Unsinn               (* UEBERFLUESSIGE AKTIONS-TABELLE *)
  (*------------------------------------------------------------*)
     return;                    (* kann niemals erreicht werden *)
  #END
*/
 Unsinn: {
  {
   __cnt(12);
  return;
 }}
}


static long __tz[13];
static struct __t { int f; long *c; struct __t *t; const char *s[8]; }
__ts = { 0, __tz, 0L, 
{"ASteuerung"
,"ATitelzeile"
,"BGrundwert"
,"Bneue_Zahl"
,"Cneuer_Test"
,"CPrimzahl"
,"AUnsinn"
,"<PRIM.T>"} };
static void __cnt(int i)
{ if (!__ts.f) __rgs(&__ts.f); ++__tz[i]; }
